/*   
    
Chess-Ec     Copyright (C)   2001-2008 Marc Dechico

ec_disk.c : save restore datas on disk	
	       
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

To contact the author:	
Marc Dechico
Kerfring
29390 SCAER France
tel: 06 37 98 22 54
Mail: ec@chess-ec.org  
 
*/

 #include "ec_disk.h"

/**********************************************************/
int ini_dsk(void)
{

  /* crete the directory where to put the new files */
  cre_ec_dir();

  return 0;

}
int res_gam(void)
{
  char tc_ful_pat_dir_nam [LEN_FUL_PAT_FIL_NAM];

  /* check if an unterminated game has been saved */
  /*generate the full path name tc_ec_dir is  a constant */
  gen_ful_pat_nam((char*)tc_ec_dir,tc_ful_pat_dir_nam);

  /* generate the name of the file */
  strcat(tc_ful_pat_dir_nam, tc_fil_nam);

  /* check existance  */
  if(!access(tc_ful_pat_dir_nam,F_OK))
    rst_dsk_2(tc_ful_pat_dir_nam) ;

  return 0;
}
int sav_end_gam(void)
{
  /* save the game when normally ended (mat/stalle mat/resigned)*/

  char tc_ful_pat_dir_nam [LEN_FUL_PAT_FIL_NAM];
  char tc_fil_nam_date[40];

  /*generate the full path name tc_ec_dir is  a constant */
  gen_ful_pat_nam((char*)tc_ec_dir,tc_ful_pat_dir_nam);

  /* bug: dangerous malloc should be used*/
  /* generate the name of the file:ec-2007-0310-13:30.ech */
  gen_fil_nam(tc_fil_nam_date,sizeof(tc_fil_nam_date));
  strcat(tc_ful_pat_dir_nam, tc_fil_nam_date);

  /* save the game on disk */
  sav_dsk_2(tc_ful_pat_dir_nam);

  /* eventually delete the file created for not ended game  */
  /*generate the full path name tc_ec_dir is  a constant */
  gen_ful_pat_nam((char*)tc_ec_dir,tc_ful_pat_dir_nam);

  /* generate the name of the file:ec-20070310-1330.ech */
  strcat(tc_ful_pat_dir_nam, tc_fil_nam);

  /* delete the file */
  unlink(tc_ful_pat_dir_nam);
  return 0;
}
int sav_gam(void)
{
  /* save the game when not ended (game can continue) */

  char tc_ful_pat_dir_nam [LEN_FUL_PAT_FIL_NAM];

  /*generate the full path name tc_ec_dir is  a constant */
  gen_ful_pat_nam((char*)tc_ec_dir,tc_ful_pat_dir_nam);

  /* generate the name of the file:ec-20070310-1330.ech */
  strcat(tc_ful_pat_dir_nam, tc_fil_nam);

  /* save the game move on disk */
  sav_dsk_2(tc_ful_pat_dir_nam);

  return 0;

}
int save_configuration(void)
{
  /* save the configuration  */

  char tc_ful_pat_dir_nam [LEN_FUL_PAT_FIL_NAM];

  /*generate the full path name tc_ec_dir is  a constant */
  gen_ful_pat_nam((char*)tc_ec_dir,tc_ful_pat_dir_nam);

  /* generate the name of the file:ec.conf */
  strcat(tc_ful_pat_dir_nam, tc_con_fil_nam);

  /* save the game move on disk */
  sav_dsk_conf(tc_ful_pat_dir_nam);

  return 0;

}
int restore_configuration(void)
{
  char tc_ful_pat_dir_nam [LEN_FUL_PAT_FIL_NAM];

  /* check if an unterminated game has been saved */

  /*generate the full path name tc_ec_dir is  a constant */
  gen_ful_pat_nam((char*)tc_ec_dir,tc_ful_pat_dir_nam);

  /* generate the name of the file */
  strcat(tc_ful_pat_dir_nam, tc_con_fil_nam);

  /* check existance  */
  if(!access(tc_ful_pat_dir_nam,F_OK))
    restore_configuration_dsk(tc_ful_pat_dir_nam) ;

  return 0;
}

int cre_ec_dir(void)
{
  /* create the directory to put the all the ec_files */
  char tc_ful_pat_dir_nam [LEN_FUL_PAT_FIL_NAM];

  /*generate the fulla path name */
  /* tc_ec_dir is a constant string containing the name of the ec directory */
  gen_ful_pat_nam((char*)tc_ec_dir,tc_ful_pat_dir_nam);

  /* create it */
  mkdir (tc_ful_pat_dir_nam,S_IRWXU|S_IRGRP|S_IROTH);

  return 0;
}
int gen_fil_nam(char * tc_name,int i_size)
{
  time_t t;
  struct tm *tm;
  const char tc_format[]="/ec-%Y-%m%d-%H:%M.ech";
  int i_size_name=24;
  /* generate a name like ec-20070413-1330.ech */
  if (i_size>=i_size_name)
    {
      t=time(NULL);
      tm=localtime(&t);
      strftime(tc_name,i_size_name,tc_format,tm);
      strcat(tc_name,"\0");
      return 0;

    }
  else
    return -1;

}

int gen_ful_pat_nam (char * tc_nom_fic,char * tc_ful_pat_fil_nam)
{ 
  /* generate the path name */

  if (tc_nom_fic == NULL || tc_ful_pat_fil_nam == NULL )
    return -1;

  if (  ( strlen (getenv("HOME")) + strlen (tc_nom_fic) +1 +1  ) < LEN_FUL_PAT_FIL_NAM )
    {
      strcpy(tc_ful_pat_fil_nam,getenv("HOME"));
      strcat(tc_ful_pat_fil_nam,"/");
      strcat(tc_ful_pat_fil_nam,tc_nom_fic);
      return 0;
    }
  else
    {
      return -1;
    }
}
int sav_dsk(char * tc_nom_fic)
{
  char tc_ful_pat_fil_nam [LEN_FUL_PAT_FIL_NAM];

  if (gen_ful_pat_nam(tc_nom_fic,tc_ful_pat_fil_nam) < 0) 

    /* bug : message non approprié */
    return -MSG_SAV_DSK_ERR_FIC;

  return sav_dsk_2(tc_ful_pat_fil_nam);

}
int sav_dsk_2(char * tc_ful_pat_fil_nam)
{
  int i_cpt_hst;
  FILE *pf_std;
 
  if ( (pf_std= fopen(tc_ful_pat_fil_nam,"w")) !=NULL )
    {
      for (i_cpt_hst=1;i_cpt_hst<=i_pro_act;i_cpt_hst++)
	{
	  fprintf(pf_std,"%s%s%c\n",
		  tc_lib_cas[ts_hst_pro[i_cpt_hst].i_pos_ori_n],
		  tc_lib_cas[ts_hst_pro[i_cpt_hst].i_pos_n],
		  pro_pio_tra_tmvt_tpie(ts_hst_pro[i_cpt_hst].i_typ_mvt));
		
	}
      fclose (pf_std);
	
    }
  else
    {
      /*Erreur d'ecriture */
      return -MSG_SAV_DSK_ERR_FIC;
    }
  return 0;
}
int sav_dsk_conf(char * tc_ful_pat_fil_nam)
{
  FILE *pf_std;
 
  if ( (pf_std= fopen(tc_ful_pat_fil_nam,"w")) !=NULL )
    {

      /* save difficulty level */
      //extern struct st_ver tst_ver [VER_NBR];
      extern int i_ver_eva;	
      fprintf(pf_std,tc_con_difficulty_format,i_ver_eva);

      /* save depth  level   depth:l4.4 */
      extern int i_pro_sim_niv;			
      extern int i_pro_sim_inc;			
      fprintf(pf_std,tc_con_depth_format, i_pro_sim_niv, i_pro_sim_inc);
	      	      
		
      fclose (pf_std);
	
    }
  else
    {
      /*Erreur d'ecriture */
      return -MSG_SAV_DSK_ERR_FIC;
    }
  return 0;
}
int rst_dsk(char tc_nom_fic[100])
{
  char tc_ful_pat_fil_nam [LEN_FUL_PAT_FIL_NAM];
  if (gen_ful_pat_nam(tc_nom_fic,tc_ful_pat_fil_nam) < 0) 

    /* bug : message non approprié */
    return -MSG_SAV_DSK_ERR_FIC;

  ini_pgm();

  return rst_dsk_2(tc_ful_pat_fil_nam);

}
int rst_dsk_2(char * tc_ful_pat_fil_nam)
{
  char tc_dep[3];               		/* case de depart ex:A1 */
  char tc_arr[4];               		/* case d'arrivée ex:B2 ou A8C pour pion en cavalier */
  int i_mei_mvt;
  FILE *pf_std;
  extern void not_cal(void);

  if ( (pf_std= fopen(tc_ful_pat_fil_nam,"r")) !=NULL )
    {
      while(fscanf(pf_std,"%2s%3s\n",tc_dep,tc_arr)!=EOF)
	{
	  printf("\n%s%s",tc_dep,tc_arr);
	  /* traduction type de piece vers lib piece pour prise en compte de la langue */	
	  tc_arr[2]=pro_pio_tra_tpie_lpie(tc_arr[2]);
	  if(jou_int(tc_dep,tc_arr)<0) 
	    /* Erreure donnee (mvt invalide)*/
	    return -MSG_RST_DSK_ERR_DON;
	  else
	    {
	      i_mei_mvt= simul(2,0,
			       USE_HASH_NO,
			       INI_MVT_INI_NO,
			       INI_RAP_FOR_NO,
			       NULL,
			       pts_hst_pro->i_cam);
	      if (i_mei_mvt<0)  	
		/* Partie termine car echec ou pat */
		return i_mei_mvt;   
	    }
			
	}
      fclose (pf_std);
    }
  else
    {
      /* Erreur de lecture: avez vous deja enregistre une partie avec fl?*/
      return -MSG_RST_DSK_ERR_FIC;
    }
  /* set the side for the play and the printing */     
  extern int get_turn(void);
 if(get_turn()== BLANC)

   i_cot_aff=BLANC;
 else
   i_cot_aff=NOIR;
 
 i_side=i_cot_aff;
 
 return 0;
}
int restore_configuration_dsk(char * tc_ful_pat_fil_nam)
{
  FILE *pf_std;

  if ( (pf_std= fopen(tc_ful_pat_fil_nam,"r")) !=NULL )
    {
      /* difficulty level */
      extern int i_ver_eva;	
      fscanf(pf_std,tc_con_difficulty_format,&i_ver_eva);

      /* depth  level   depth:l4.4 */
      extern int i_pro_sim_niv;			
      extern int i_pro_sim_inc;			
      fscanf(pf_std,tc_con_depth_format, &i_pro_sim_niv, &i_pro_sim_inc);

      //if(fscanf(pf_std,"%2s%3s\n",tc_dep,tc_arr)!=EOF)
      fclose (pf_std);
    }
  else
    {
      /* Erreur de lecture: avez vous deja enregistre une partie avec fl?*/
      return -MSG_RST_DSK_ERR_FIC;
    }
 
 return 0;
}
