/* 
    Chess-Ec      Copyright (C)   2001-2008 Marc Dechico


    ec_menu.h : Teletyp interface to let the user play
    
     
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

    To contact the author:	Marc Dechico
			        Kerfring
			        29390 SCAER France
				tel: 06 37 98 22 54
				Mail: ec@chess-ec.org  
    
*/

#include "ec_global.h"

/*************************************************/
/* external data                                 */
/*************************************************/
extern  char tc_sep_tir[];
extern char package_string[];
extern char package_bugreport[];
extern char package_www[];
extern volatile defv_bool defv_bool_sigterm; 

extern struct st_aff tst_aff[st_aff_dim];

/* tableau historique des coups */
extern  struct st_hst_pro ts_hst_pro[PRO_HST];

extern struct st_pie ts_pie_0[18];/* pèce camp 0			*/

extern struct st_pie ts_pie_1[18];/* pièce camp 1			*/

extern struct st_pie *tpts_pie[2];/* tableau pointant sur pièce camp 0 ou 1 */
                                  /* poste 0 camp 0, 1 camp 1 */

extern struct st_ech ts_ech[100]; /* tableau echiquier accès par l'emplacement  */

extern struct st_eva_sit st_eva_sit;/* structure pour evaluation rapport de force */

extern int (*pf_eva) (void);  	  /* pointeur sur fonction evaluation */

extern int (*tpf_eva[100]) (void);/* tableau pointeur sur fonction evaluation */

extern defv_bool defv_aff_not_pos;    /* =1 si affichage note possible */

extern defv_bool defv_aff_cal_cou;	  /* = 1 si affichage calcul en cour */

extern int i_pro_act;             /* profondeur actuelle	*/

extern int i_pro_sim_niv;	  /* niveau de simulation */

extern int i_pro_sim_inc;	  /* nivde simu pour incremen*/

extern int i_pro_sim_max_inf;     /* profondeur maximale inferieur	*/

extern defv_bool defv_sto_sim_cla;	  /* si = 1 CTL C pendant simulation-> arret simu */

extern int i_not_cpt_mvt_ini;	  /* note: compteur mvt initial 		*/

extern struct st_hst_pro *pts_hst_pro;/* ptr sur tableau structure historique  */

extern struct st_pie *pts_pie;    /* ptr sur tbl structure pièce principale*/

extern volatile defv_bool defv_bool_sigint; 

/*************************************************/
/* local  data                                   */
/*************************************************/
static char tc_sep_ast[]=
  "\n*******************************************************************************";





/*************************************************/
/* external functions                            */
/*************************************************/

extern void 	ini_pgm 	(void);
/* joue interactif + reponse ordinateur  */
extern int      jou_int_jou	(char *ptc_dep,	         
				 char *ptc_arr);
/* joue interactif + controle echec  */
extern int      jou_int_ctl	(char *ptc_dep,	        	
				 char *ptc_arr);
 /* simul et joue  */
extern int      sim_jou         (void);                        
 /* annule coup interactif */
extern int      ann_cou_int     (void);	                       
/* Chargement variable avec message */
extern int      cha_mes         (int i_mes_num,                 
				 char *tc_lib_mes);
/*ec_simu */
/* simulation pour evaluation meilleur mvt */
extern int      simul_eva       (int i_pro_sim_niv_wrk,         
				 int i_pro_sim_inc_wrk	);
/* Stop simulation  */
extern void     sto_sim 	 (void);	        	
 /* verifie validite du libelle piece promotion du pion */
extern  int     pro_pio_ver_lib_pie    (char c_lib_pie);       
 /* verifie validite du type piece promotion du pion */
extern  int     pro_pio_ver_typ_pie    (char c_typ_pie);       
/* traduit type piece en libelle piece*/
extern char     pro_pio_tra_tpie_lpie  (char  i_typ_pie);      
 /* traduit type mvt en type  piece*/ 
extern  char    pro_pio_tra_tmvt_lpie  (int i_typ_mvt);        
 /* traduit libelle piece en type piece */
extern  char    pro_pio_tra_lpie_tpie  (char c_lib_pie);       
 /* Choix profondeur et incrément de simulation */
extern  int     cho_niv                (int i_niv, int i_inc); 
 /* Sauvegarde et restauration partie sur disque */
extern  int     sav_dsk                (char tc_nom_fic[40]);  
extern  int     rst_dsk                (char tc_nom_fic[40]);

/*ec_eva*/
/* analyse de la couverture */
extern float 	eva_cou_cam 	(int nn);	
/* pour faire jouer automatiquement */
extern void  	sim_aut 	(void);		
/* pour techercher d'éventuel bugs  */

extern  void  	test_aut 	(void);		
/* print next/previous  page   */
extern  int aff_nex_pag(struct st_evaluation *pst_eva);                       
/* common to all statistic printing */
extern  int aff_pre_pag(struct st_evaluation *pst_eva);                         

/* these are only  for debuging purpose */
extern void aff_pie (int i_cam);
extern void aff_pie_lin(int i_pie,struct st_pie *ptst_pie); 
extern  void aff_hst (int i_pro_deb, int i_pro_fin);

/* print score for the mouvement several pondered factor  */
extern  int aff_not_1 (struct st_evaluation *st_eva);
extern  int aff_not_2 (struct st_evaluation *st_eva);

/* print score for one initial moment datas for each depth  */
extern int aff_mvt_ini(int i_mvt_ini,struct st_evaluation *pst_eva);

/* Is the commande alike a move  ("E2E4") */
extern int is_mov(char *tc_com);

/*Get the side that has to  play */
extern int get_turn(void);

/* quit pgm */
extern void quit_pgm(void);
/* choix version d'évaluation */
extern void cho_ver(void);
/*choose the difficulties */
extern void cho_ver2 (int i_ver);
/* resigne game */
extern void resign (void);
extern void test01(void);

/*************************************************/
/* local    functions                            */
/*************************************************/
void mnu_cde (void);
static void mnu_cde_prt(char tc_com[80]);
static void mnu_cde_mov(char tc_com[80]);
static void mnu_cde_rec(char tc_com[80]);
static void mnu_cde_fil(char tc_com[80],int i_cot_aff);
static void mnu_hlp (void);
/* affichage aide du menu cde  */
static void mnu_hlp (void);
static void new_mnu_hlp (void);


/* affichage pied de page */
static void prt_foo (int i_pro_act,int i_pro_sim_niv,int i_pro_sim_inc);

/* affichage de l'échiquier */
void aff_ech (int i_cam);

/* gestion interruption simulation */
 void sto_sim_msg(void);

/* Affichage calcul en cours */
extern  void aff_cal_en_cou(int i_not_cpt_mvt_ini);

/* Affichage message  utilisateur  */
void aff_mes_uti(int i_mes_num); 

/* choix promotion du  pion  */
static char pro_pio_cho (void);		 
char pro_pio_cho_wra (void);

static  void sup_blanc    (char *tc_str);
static  void sai_com       (char tc_com [80]);

/* Change la prfondeur de simulation */
static int chg_lvl(char *tc_com);
/* New menu */
int new_menu (char * tc_com);
/* commande inconnue */
static void cde_inc (void);
/* signal hadler for the menu */
void sto_menu(int i_sig);

